%% Fachpraktikum - Inverted Pendulum

%% a) System equations
% parameters
Mp = 0.104;         %   [kg]    pendulum mass 
Mc = 1.79;          %   [kg]    cart mass
lp = 0.1524;        %   [m]     pendulum length from pivot to center of gravity
Lp = 2*lp;          %           full pendulum length
g  = 9.81;          %   [m/s^2] gravitational acceleration
b  = 0.001;         %   [Ns/m]  friction coefficient
n  = 1;             %   []      motor efficiency
Kt = 0.07;          %   [Nm/A]  motor torque constant
r  = 6.35e-3;       %   [m]     motor pinion radius
r_mp = r;           %           for simulation
IMAX_UPM = 10;      %   [A]     maximum current
Ip = Mp * Lp^2 / 12; %          Pendulum Moment of Inertia
Bp = 0.0024;        %   [Nms/rad] Equivalent Viscous Damping Coefficient 
Jm = 1.64e-5;       %   [Nm/A]  Motor Torque Constant 
Eff_m = 1;      
Beq = 0;            %   [Ns/m]  Equivalent Viscous Damping Coefficient 

% state space matrices [x, phi, x., phi.]
A_ss = ...
B_ss = ...
C_ss = ...
D_ss = ...

%% LQR
% weight matrices
Q = ...
R = ...

% state space representation of the system
mysys = ...

% optimal feedback gain
Klqr = ...
K = Klqr; 

% stabilising control between =- phi_stab [deg];
phi_stab = 20;

% starting position
X0 = [0 3 0 0];
